#Reversing a string

#non-recursive version
def reverseWord(word):
    revWord = ""                                #start reversed word as blank
    x = len(word) - 1                           #find the length of the input word

    for i in range(x,-1,-1):                    #start at end of word & move backwards
        letter = word[i]                        #get the letter
        revWord = revWord + letter              #add it to end of revWord

    return revWord


##recursive version 01
def reverseWordRecur01(word):
    #check if the word is empty to avoid run time error
    if word == "":
        return "" #if the word is empty, return an empty string
    
    if len(word) == 1: #base case: when there is only one letter in the word
        return word[0] #return that letter
    else:
        return reverseWordRecur01(word[1:]) + word[0]   

##recursive version 02
def reverseWordRecur02(word):
    #check if the word is empty to avoid run time error
    if word == "":
        return "" #if the word is empty, return an empty string
    
    if len(word) == 1: #base case 1: when there is only one letter in the word
        return word[0] #return that letter
    elif len(word) == 2: #base case 2: when there are two letters in the word
        return word[1] + word[0] #reverse the 2 letters
    else:
        length = len(word)
        mid = length / 2
        firstPart = word[0:mid] #get the first half of the word
        secondPart = word[mid:] #get the second half of the word
        return reverseWordRecur02(secondPart) + reverseWordRecur02(firstPart) #reverse the first part and the second part
    
##recursive version 03
def reverseWordRecur03(word):
    if word == "" or len(word)== 1:
        return word #if the word is empty, return an empty string
    else:
        return word[len(word)-1] + reverseWordRecur03(word[1:len(word)-1]) + word[0]

word = raw_input("Enter a word: ")
    
print "The original word was",word
print "Result of non-recursive version:",reverseWord(word)
print "Result of recursive version 01 :",reverseWordRecur01(word)
print "Result of recursive version 02 :",reverseWordRecur02(word)
print "Result of recursive version 03 :",reverseWordRecur03(word)


